-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

newTalent{
	name = "Glancing Blows",
	type = {"corruption/survivors-fortitude", 1},
	mode = "passive",
	points = 5,
	info = function(self, t)
		return ([[Blows can now can bounce of you. Each blow against you has a %d chance to deal 25%% damage]]):
		format(5*self:getTalentLevel(t))
	end,
}

newTalent{
	name = "Tenacity of Spite",
	type = {"corruption/survivors-fortitude", 2},
	require = corrs_req2,
	mode = "passive",
	points = 5,
	on_absorb = function(self, t, damtype)
		if not DamageType:get(damtype).antimagic_resolve then return end

			local health = 1 + self:combatTalentSpellDamage(t, 10, 30)
			local stamina = 1 + self:combatTalentSpellDamage(t, 10, 10)
			self:heal(health)
			self:incStamina(stamina)
		self:setEffect(self.EFF_RESOLVE, 7, {damtype=damtype, res=self:combatTalentSpellDamage(t, 10, 40)})
		game.logSeen(self, "%s is invigorated by the attack!", self.name:capitalize())
	end,
	info = function(self, t)
		return ([[You stand in the way of magical damage. Each time you are hit by a magical damage you get a %d%% resistance to this element for 7 turns.
		you also absorb part of the impact and use it to fuel your own powers, increasing your health by %d and increasing your stamina by %d.
		The effects will increase with your Magic stat.]]):
		format(
			self:combatTalentSpellDamage(t, 10, 40),
			1 + self:combatTalentSpellDamage(t, 10, 30),
			1 + self:combatTalentSpellDamage(t, 10, 10)
		)
	end,
}

newTalent{
	short_name = "DEATHS_ENDURANCE",
	name = "Endurance of the Reaper",
	type = {"corruption/survivors-fortitude", 3},
	require = corrs_req3,
	mode = "passive",
	points = 5,
	info = function(self, t)
		return ([[You bask in the glory of each kill.  But unlike others you know you must survive to make the next kill.  Each time you kill a creature you raise your defense by %d for %d turns]]):
		format(4 * self:getTalentLevel(t),5+self:getTalentLevel(t)*2)
	end,
}

newTalent{
	name = "Last Grasps",
	type = {"corruption/survivors-fortitude", 4},
	require = corrs_req4,
	points = 5,
	vim = 60,
	no_energy = true,
	cooldown = 150,
	tactical = { ATTACKAREA = 1, DISABLE = 2, ESCAPE = 2 },
	action = function(self, t)
		if self.life<self.max_life*.2 then  self:setEffect(self.EFF_LAST_GRASP, 2+self:getTalentLevel(t)/2, {power=(self:getTalentLevel(t)*4)},false) return true 
		end
		game.logPlayer(self, "You must be closer to death") 
		return nil	
	end,
	info = function(self, t)
		return ([[You have seen to much and have gone to far to die now.  You cling to the last grasps of life.  When below 20%% health you raise your resist all by %d and your resist all cap by %d for %d turns]]):format(self:getTalentLevel(t)*4,self:getTalentLevel(t)*6,2+self:getTalentLevel(t)/2)
	end,
}
